########################################################################
# Elementary vector functions
########################################################################
rotateVect=function(X, alpha)
{
    alpha=alpha/180*pi
    R=matrix(c(cos(alpha),sin(alpha),-sin(alpha),cos(alpha)),2,2)
 return(t(R%*%c(X[1],X[2])))
}

pscal=function(P1,P2){
 return(sum(P1*P2));
}
pvect=function(i,j){
  return(c(i[2]*j[3]-i[3]*j[2] , i[3]*j[1]-i[1]*j[3] , i[1]*j[2]-i[2]*j[1] )) 
}

v.norm=function(x){return(sqrt(x%*%x))}
getNorm=function(P1){ return(sqrt(x%*%x)) }

getDistance=function(P1,P2){
 return(sqrt( (P2[1]-P1[1])^2 + (P2[2]-P1[2])^2   ))
}
getAngle=function(P1,P2,P3){
 return(sqrt( (P2[1]-P1[1])^2 + (P2[2]-P1[2])^2   ))
}


