############################################################################################################################
# Elementary list functions
############################################################################################################################
list.range=function(L=list()){
  return(c(list.min(L),list.max(L)))
}
list.min=function(L=list()){
  aux=numeric();
  for(i in 1:length(L)){
    aux=c(aux,min(L[[i]],na.rm=T))
  }
  return(min(aux,na.rm=TRUE))
}
list.max=function(L=list()){
  aux=numeric();
  for(i in 1:length(L)){
    aux=c(aux,max(L[[i]],na.rm=T))
  }
  return(max(aux,na.rm=TRUE))
}

list.add=function(L1=list(),L2=list()){
  for(i in 1:length(L1)){
    L1[[i]]=L1[[i]]+L2[[i]]
  }
  return(L1)
}

list.scalarmul=function(L=list(),a=1){
  for(i in 1:length(L)){
    L[[i]]=L[[i]]*a
  }
  return(L)
}

list.cbind=function(L=list(),V=numeric()){
  L[[length(L)+1]]=V
  return(L)
}
