printf=function(...){
  print(sprintf(...))
}

formatEng <- function(X) {
   out=character()
   for(x in X){ 
      s<-as.numeric(strsplit(format(x, scientific=T),"e")[[1]])
      p=as.integer(s[2]-(s[2]%%3))
      if(p==0){ out=c(out,x)}
      else{
            if(p>0){p=paste("+",p,sep="")}
            out=c(out,paste(s[1]*10^(s[2]%%3),p,sep="e"))
      }
  }
  return(out)
}

seq.log=function(x1,x2="1"){
	if(length(x1)==2){x2=x1[2];x1=x1[1];}
	n1=floor(log(x1)/log(10))
	n2=floor(log(x2)/log(10))
	suff=NULL;
	if(x1==1000){n1=n1+1;}
	if(x2==1000){suff=1000;}
	if(n2-(log(x2)/log(10))==0){
		n2=n2-1;
		suff=x2;
	}
	dn=n2-n1+1
	return(c(as.vector( t(10^(log(matrix(1:9,dn,9,byrow=T)  )/log(10)+matrix(n1:n2,dn,9) ))),suff))
}

#seq.log(range(Vn))
#seq.log(1.2,100)
#seq.log(range(Vn))

nextint=function(v){
w=numeric(length(v))
for(i in 1:length(v)){
	if(v[i]<0){
		w[i]=floor(v[i]);
	}else{
		w[i]=ceiling(v[i]);
	}
}
return(w)
}

powerrange=function(x1,x2="1"){
	if(length(x1)==2){x2=x1[2];x1=x1[1];}
	n1=floor(log(x1)/log(10))
	aux=log(x2)/log(10);
	if(aux<0 && abs((aux%%1))>10^(-12)  )  {
		n2=ceiling(aux);
	}else{	n2=ceiling(aux)-1;}
	n2=ceiling(log(x2)/log(10))
	return(c(n1,n2))
}
 #powerrange(rY)

range.log=function(X){
	return(10^nextint(log(range(X,na.rm=T))/log(10)))
}
range.decade=function(X){
	return(nextint(log(range(X,na.rm=T))/log(10)))
}



