BierboomScaleGusts=function(l,N){
  n=length(l);
  Gusts_scaled=matrix(NA,n,81)
  pb<-txtProgressBar(0,n)
  for(i in 1:n){
     Gust= l[[i]];
     lg=length(Gust)
     indices=(-40:40)+floor(lg/2)+1
   #  print(floor(lg/2)+1)
   #  print(indices)
     # doing spline interpolation
     Gust[is.na(Gust)]=0
    # print(Gust)
     if(indices[1]<=0){print("ce gust pue");

        Gusts_scaled[i,]=rep(NA,81)
     }
     else{
    #   print(Gust[indices])
       Gusts_scaled[i,]=Gust[indices]
     }

     setTxtProgressBar(pb,i)
  }
  close(pb)
  return(Gusts_scaled)
}
# mainBierboomScaleGusts(A=-1)


scaleGusts=function(l,N){
  n=length(l);
  Gusts_scaled=matrix(NA,n,N)
  pb<-txtProgressBar(0,n)
     print(n)
  for(i in 1:n){
     Gust= l[[i]];
     # doing spline interpolation
     Gust[is.na(Gust)]=0
     Gusts_scaled[i,]=spline(1:length(Gust),Gust,N)[[2]];
     setTxtProgressBar(pb,i)
  }
  close(pb)
  return(Gusts_scaled)
}


scaleGustsFromFile=function(dir="E:/Gusts/2007", flag="GustsMonthR",year=2007,month=1,day=10,signal="MM3_WS80_240",N=100,Front=FALSE){
  fop=try(setwd(paste(dir,month,sep="/")),TRUE)
  if(!inherits(fop,"try-error")){
    filename=getFileName(flag,year,month,day,signal=signal)
    load(filename)
    if(flag=="GustsMonthR"){
       Gusts=Gusts_Month
       Gusts_info_Month=scaleGusts(Gusts,N)
    }
    if(flag=="GustsDayR"){
       Gusts=Gusts_Day
       Gusts_info_Month=scaleGusts(Gusts,N)
    }
    print(paste(dir,filename))
    filename=getFileName(paste(flag,"Scaled",sep=""),year,month,day,signal=signal)
    save(Gusts_info_Month,file=filename)
  }else{print(paste(dir , "doesn't exist"))}
}



BierboomScaleGustsFromFile=function(dir="E:/Gusts/2007", flag="GustsMonthR",year=2007,month=1,day=10,signal="MM3_WS80_240",N=21,Front=FALSE){
  fop=try(setwd(paste(dir,month,sep="/")),TRUE)
  if(!inherits(fop,"try-error")){
    filename=getFileName(flag,year,month,day,signal=signal)
    load(filename)
    if(flag=="GustsMonthR"){
       Gusts=Gusts_Month
       Gusts_info_Month=BierboomScaleGusts(Gusts,N)
    }
    if(flag=="GustsDayR"){
       Gusts=Gusts_Day
       Gusts_info_Month=BierboomScaleGusts(Gusts,N)
    }
    print(paste(dir,filename))
    filename=getFileName(paste(flag,"Scaled",sep=""),year,month,day,signal=signal)
    save(Gusts_info_Month,file=filename)
  }else{print(paste(dir , "doesn't exist"))}
}

