plotQualityOverviewCombined=function(t,x,wd,name="WS [m/s]",ymax=30,colr=2){
	xBad=x[which(x==99.99)]*0
	tBad=t[which(x==99.99)]
	x2Bad=x[which(wd==999)]*0-0.5
	t2Bad=t[which(wd==999)]
	x[which(x==99.99)]=NA
	x[which(wd==999)]=NA
	beginPlot(main=paste(name,"combined quality overview",sep=" "),width=18,height=6.5)
		plot(t,x,pch=".",cex=0.5,col=4,ylim=c(-0.7,ymax),ylab=name,xaxs="i")
		#par(new=T)
		points(tBad,xBad, pch="|",cex=0.9,col=colr)
		points(t2Bad,x2Bad, pch="|",cex=0.9,col=3)
		legend("topright", c("Valid Data","WS NA Flag","WD NA Flag") ,col=c(4,colr,3),inset = .02,ncol=1,lwd=1,cex=0.8,bg="white",lty=c(1,0,0),pch=c("","|","|"))			
	endPlot()
}
#plotQualityOverviewCombined(timestamp,WS,WD)



plotQualityOverview=function(t,x,BAD=99.9,name="WS",ymax=30,colr=2){
	xBad=x[which(x==BAD)]*0
	tBad=t[which(x==BAD)]
	x[which(x==BAD)]=NA
	beginPlot(main=paste(name,"quality overview",sep=" "),width=18,height=6.5)
		plot(t,x,pch=".",cex=0.5,col=4,ylim=c(0,ymax),ylab=name,xaxs="i")
		#par(new=T)
		points(tBad,xBad, pch="|",cex=0.9,col=colr)
	legend("topright", c("Valid Data","NA Flag") ,col=c(4,colr),inset = .02,ncol=1,lwd=1,cex=0.8,bg="white",lty=c(1,0),pch=c("","|"))
	endPlot()
}







# Validation
#~ WS[which(WS==0)]=0.00001
#~ WS[which(WS==99.99 | WD==999)]=99.99
#~ I=(10*365*24*6+24*6*30*6):(12*365*24*6-24*6*30*5)
#~ plotQualityOverview(timestamp[I],WS[I],BAD=99.99,name="WS zoom[m/s]",ymax=30)
#~ 



#ddates=as.character(floor(M[,1]/10000)%%1000000);
#timestamp=chron(dates.=ddates,format=c("ymd"))
#~ th=floor((M[,1]%%10000)/100);
#~ tm=M[,1]%%100;
#~ ttimes=sprintf("%02d:%02d:00",th,tm)
#~ timestamp=chron(dates.=ddates,times.=ttimes,format=c("ymd","h:m:s"))
#getTimeTicksPosition(timestamp);
